﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class BooleanPushExpression : Expression
    {
        public BooleanPushExpression(bool value) : base(OpCode.BooleanPush)
        {
            this.Value = value;
        }

        public bool Value { get; }

        public override void Eval(IInterpreterService interpreterService)
        {
            interpreterService.BooleanStack.Push(Value);
        }

        public override string ToString()
        {
            return $"{base.ToString()}({this.Value})";
        }
    }
}
