﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class CodeIfExpression : Expression
    {
        public CodeIfExpression() : base(OpCode.CodeIf)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            // not enough arguments on stack
            if (interpreterService.BooleanStack.Count == 0 ||
                interpreterService.CodeStack.Count < 2)
                return;

            var condition = interpreterService.BooleanStack.Pop();
            var expressionFalse = interpreterService.CodeStack.Pop();
            var expressionTrue = interpreterService.CodeStack.Pop();

            interpreterService.ExecStack.Push(condition
                ? expressionTrue
                : expressionFalse);
        }
    }
}
