﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class ExecDefineExpression : Expression
    {
        public ExecDefineExpression() : base(OpCode.ExecDefine)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            Define(
                interpreterService.ExecStack,
                interpreterService.NameStack,
                interpreterService.CustomExpressions,
                value => new ExecPushExpression(value));

            // as the interpreter does not pop code expressions
            interpreterService.ExecStack.Pop();
        }
    }
}
