﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class ExecPushExpression : Expression
    {
        public ExecPushExpression(Expression value) : base(OpCode.ExecPush)
        {
            this.Value = value;
        }

        public Expression Value { get; }

        public override void Eval(IInterpreterService interpreterService)
        {
            interpreterService.ExecStack.Push(Value);
        }

        public override string ToString()
        {
            return $"{base.ToString()}({this.Value})";
        }
    }
}
