﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class FloatPushExpression : Expression
    {
        public FloatPushExpression(double value) : base(OpCode.FloatPush)
        {
            this.Value = value;
        }

        public double Value { get; }

        public override void Eval(IInterpreterService interpreterService)
        {
            interpreterService.FloatStack.Push(Value);
        }

        public override string ToString()
        {
            return $"{base.ToString()}({this.Value})";
        }
    }
}
