﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class NamePushExpression : Expression
    {
        public NamePushExpression(string value) : base(OpCode.NamePush)
        {
            this.Value = value;
        }

        public string Value { get; }

        public override void Eval(IInterpreterService interpreterService)
        {
            interpreterService.NameStack.Push(Value);
        }

        public override string ToString()
        {
            return $"{base.ToString()}({this.Value})";
        }
    }
}
