﻿using System.Collections.Generic;
using HeuristicLab.Algorithms.PushGP.Expressions;

namespace HeuristicLab.Algorithms.PushGP.Stack
{
    public interface IInterpreterService
    {
        IStack<Expression> CodeStack { get; }
        IStack<Expression> ExecStack { get; }
        IStack<string> NameStack { get; }
        IStack<bool> BooleanStack { get; }
        IStack<long> IntegerStack { get; }
        IStack<double> FloatStack { get; }

        IDictionary<string, Expression> CustomExpressions { get; }
    }
}
