﻿using System.Collections.Generic;

namespace HeuristicLab.Algorithms.PushGP.Stack
{
    public interface IStack<T> : IEnumerable<T>, ICollection<T>
    {
        void Push(T item);

        void Push(params T[] items);

        void Push(IEnumerable<T> items);

        void Insert(int index, T item);

        void Insert(int index, params T[] items);

        void Insert(int index, IEnumerable<T> items);

        T Pop();

        T[] Pop(int count);

        bool TryPop(out T item);

        T ElementAt(int index);

        T Top { get; }
    }
}
